#include <iostream>
#include <stdexcept>

#include "unittest/unittest.h"

using namespace unittest;

struct UnitTestAssertDelta
:
  public TestSuite
{
    struct AssertEqualPositive
    {
      void operator()()
      {
        double e = 3.14, d = 0.001, a = e;
        
        UNITTEST_ASSERT_DELTA(Equal, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(Equal, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(Equal, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertEqualNegative
    {
      void operator()()
      {
        double e = -3.14, d = 0.001, a = e;
        
        UNITTEST_ASSERT_DELTA(Equal, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(Equal, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(Equal, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertNotEqualPositive
    {
      void operator()()
      {
        double e = 3.14, d = 0.001, a = e - 2 * d;
        
        UNITTEST_ASSERT_DELTA(NotEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(Equal, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(NotEqual, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertNotEqualNegative
    {
      void operator()()
      {
        double e = -3.14, d = 0.001, a = e - 2 * d;
        
        UNITTEST_ASSERT_DELTA(NotEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(Equal, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(NotEqual, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertLessPositive
    {
      void operator()()
      {
        double e = 3.14, d = 0.001, a = e - 2 * d;
        
        UNITTEST_ASSERT_DELTA(Less, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(Less, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertLessNegative
    {
      void operator()()
      {
        double e = -3.14, d = 0.001, a = e - 2 * d;
        
        UNITTEST_ASSERT_DELTA(Less, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(Less, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertLessEqualPositive
    {
      void operator()()
      {
        double e = 3.14, d = 0.001, a = e - 2 * d;
        
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
          std::cout << "a=" << a << ", e=" << e << std::endl;
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    
    struct AssertLessEqualNegative
    {
      void operator()()
      {
        double e = -3.14, d = 0.001, a = e - 2 * d;
        
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
        a += d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(LessEqual, e, a, d);
          std::cout << "a=" << a << ", e=" << e << std::endl;
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertGreaterPositive
    {
      void operator()()
      {
        double e = 3.14, d = 0.001, a = e + 2 * d;
        
        UNITTEST_ASSERT_DELTA(Greater, e, a, d);
        a -= d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(Greater, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertGreaterNegative
    {
      void operator()()
      {
        double e = -3.14, d = 0.001, a = e + 2 * d;
        
        UNITTEST_ASSERT_DELTA(Greater, e, a, d);
        a -= d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(Greater, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertGreaterEqualPositive
    {
      void operator()()
      {
        double e = 3.14, d = 0.001, a = e + d;
        
        UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
        a -= d;
        UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
        a -= d;
        UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
        a -= d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    struct AssertGreaterEqualNegative
    {
      void operator()()
      {
        double e = -3.14, d = 0.001, a = e + d;
        
        UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
        a -= d;
        UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
        a -= d;
        UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
        a -= d;
        
        try
        {
          UNITTEST_ASSERT_DELTA(GreaterEqual, e, a, d);
          throw std::logic_error("unreachable code");
        } /* end of try */
        catch (Exception const &)
        {
          //nop
        } /* end of catch */
      }
    };
    
    
  UnitTestAssertDelta()
  {
    add(TestBasePtr(new Test<AssertEqualPositive>));
    add(TestBasePtr(new Test<AssertEqualNegative>));
    add(TestBasePtr(new Test<AssertNotEqualPositive>));
    add(TestBasePtr(new Test<AssertNotEqualNegative>));
    add(TestBasePtr(new Test<AssertLessPositive>));
    add(TestBasePtr(new Test<AssertLessNegative>));
    add(TestBasePtr(new Test<AssertLessEqualPositive>));
    add(TestBasePtr(new Test<AssertLessEqualNegative>));
    add(TestBasePtr(new Test<AssertGreaterPositive>));
    add(TestBasePtr(new Test<AssertGreaterNegative>));
    add(TestBasePtr(new Test<AssertGreaterEqualPositive>));
    add(TestBasePtr(new Test<AssertGreaterEqualNegative>));
  }
};

static AutoRegister < UnitTestAssertDelta > ts;
